//
//  ResultViewController.m
//  SampleImplicitApp
//
//  Copyright (c) 2013年 Yahoo Japan Corporation. All rights reserved.
//

#import "ResultViewController.h"
#import "StartViewController.h"
#import "YConnectSDK.h"

// アプリケーションID
static NSString * const CLIENT_ID = @"あなたのアプリケーションID";
// コールバックURL
// (アプリケーションID発行時に登録したURI)
static NSString * const REDIRECT_URI = @"yj-xxxxx://cb";


@interface ResultViewController ()

@end

@implementation ResultViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // コールバックURLから各パラメーターを抽出
    YConnectImplicit *yconnect = [YConnectImplicit getInstance];
    [yconnect parseAuthorizationResponse:self.url customUriScheme:@"yj-xxxxx://" state:yconnect.requestClient.state];
    // アクセストークン、リフレッシュトークン、IDトークンを取得
    NSString *accessTokenString = [yconnect getAccessToken];
    long expiration = [yconnect getAccessTokenExpiration];
    NSString *idTokenString = [yconnect getIdToken];
    NSLog(@"accessTokenString:%@, expiration:%ld, idTokenString:%@", accessTokenString, expiration, idTokenString);
    
    // CheckTokenエンドポイントにリクエスト
    [yconnect requestCheckIdToken:idTokenString nonce:yconnect.nonce clientId:CLIENT_ID];
    // 復号化されたIDトークン情報を取得
    IdTokenObject *idTokenObject = [yconnect getIdTokenObject];
    NSLog(@"iss:%@", idTokenObject.iss);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (IBAction)requestUserinfoAction:(id)sender
{
    
    YConnectImplicit *yconnect = [YConnectImplicit getInstance];
    NSString *accessTokenString = [yconnect getAccessToken];
    @try {
        // UserInfoエンドポイントにリクエスト
        [yconnect requestUserInfo:accessTokenString];
        // UserInfo情報を取得
        UserInfoObject *userInfoObject = [yconnect getUserInfoObject];
        NSLog(@"userId:%@", userInfoObject.userId);
    }
    @catch (NSException *exception) {
        if ([exception.reason isEqualToString:@"invalid_token"]) {
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"エラー"
                                                                           message:@"ログインし直してください"
                                                                    preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:nil];
            [alert addAction:action];
            [self presentViewController:alert animated:YES completion:nil];
        }
    }
}

@end
