//
//  HttpClient.h
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "HttpParameters.h"
#import "HttpHeaders.h"

@interface HttpClient : NSObject
@property (nonatomic) int responseCode;
@property (nonatomic, retain) HttpHeaders *responseHeaders;
@property (nonatomic, retain) NSString *responseBody;
//リクエストに追加する本文
@property (nonatomic, retain) id requestBody;
//接続タイムアウト(デフォルト60秒)
@property (nonatomic) NSTimeInterval timeout;

@property (nonatomic, retain) NSURLResponse *response;
@property (nonatomic, retain) NSData *responseData;
@property (nonatomic, retain) NSError *error;

- (void)requestGet:(NSString *)urlString parameters:(HttpParameters *)parameters requestHeaders:(HttpHeaders *)requestHeaders;
- (void)requestPost:(NSString *)urlString parameters:(HttpParameters *)parameters requestHeaders:(HttpHeaders *)requestHeaders;
- (void)requestPut:(NSString *)urlString parameters:(HttpParameters *)parameters requestHeaders:(HttpHeaders *)requestHeaders;
- (void)requestDelete:(NSString *)urlString parameters:(HttpParameters *)parameters requestHeaders:(HttpHeaders *)requestHeaders;
- (void)readResponseBody;
- (int)getStatusCode;
+ (void)enableSSLCheck;
+ (void)disableSSLCheck;
@end
