//
//  APIClient.h
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BearerToken.h"
#import "HttpClient.h"
#import "HttpHeaders.h"
#import "HttpParameters.h"
#import "APIClientException.h"

@interface APIClient : NSObject
@property (nonatomic, retain) NSString *responseBody;
@property (nonatomic, retain) HttpHeaders *responseHeaders;
@property (nonatomic) int responseCode;
@property (nonatomic, retain) NSString *requestBody; //リクエストで送る本文
@property (nonatomic, retain) HttpHeaders *requestHeaders;
@property (nonatomic, retain) HttpParameters *parameters;

@property (nonatomic) BOOL isShouldMoveAccessTokenFromParameterToHeader; //追加
@property (nonatomic) NSTimeInterval apiTimeout;

@property (nonatomic, retain) HttpClient *httpClient;

+ (NSString *) POST_METHOD;
+ (NSString *) GET_METHOD;

- (id) init;
- (id) initWithAccessTokenString:(NSString *)accessToken;
- (id) initWithAccessToken:(BearerToken *)accessToken;
- (void) fetchResource:(NSString *)url method:(NSString *)method;
- (void) setParameter:(NSString *)name value:(NSString *)value;
- (void) setHeader:(NSString *)field value:(NSString *)value;
- (void) setAccessToken:(BearerToken *)accessToken;

- (void)moveAccessTokenFromParameterToHeader;
@end
