//
//  ExplicitCallbackUriParser.m
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import "ExplicitCallbackUriParser.h"

//Explicit flowでのコールバック処理

@implementation ExplicitCallbackUriParser

//初期化
- (id)initWithRedirectUri:(NSURL *)redirectUri callBackUri:(NSString *)callBackUri {
    self = [super initWithRedirectUri:redirectUri callBackUri:callBackUri];
    return self;
}
//authorization codeを取得
- (NSString *)getAuthorizationCode:(NSString *)state {
    if ([state isEqualToString:[parameters objectForKey:@"state"]]) {
        NSString *authCodeString = [parameters objectForKey:@"code"];
        if (authCodeString != nil) {
            return authCodeString;
        } else {
            NSLog(@"%@: No authorization code parameters.", NSStringFromClass([self class]));
            //例外をスロー
            @throw [[AuthorizationException alloc] initWithName:@"NoAuthorizationCodeParameters" reason:@"No authorization code parameters." userInfo:nil];
        }
    } else {
        NSLog(@"%@: Not match state.", NSStringFromClass([self class]));
        //例外をスロー
        @throw [[AuthorizationException alloc] initWithName:@"NotMatchState" reason:@"Not match state." userInfo:nil];
    }
}

@end
