//
//  OAuth2ResponseType.m
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import "OAuth2ResponseType.h"
static NSString * const CODE = @"code";
static NSString * const TOKEN = @"token";
static NSString * const IDTOEKN = @"id_token";
static NSString * const CODE_IDTOKEN = @"code%20id_token";
static NSString * const TOKEN_IDTOKEN = @"token%20id_token";

@implementation OAuth2ResponseType

/**
 * Authコード(Explicit)のレスポンス形式を指定(OAuth)
 * @return NSString *
 **/
+ (NSString *)CODE {
    return CODE;
}
/**
 * アクセストークン(Implicit)の形式を指定(OAuth)
 * @return NSString *
 **/
+ (NSString *)TOKEN {
    return TOKEN;
}
/**
 * IDトークンの形式を指定
 * @return NSString *
 **/
+ (NSString *)IDTOKEN {
    return IDTOEKN;
}
/**
 * AuthコードとIDトークンの形式を指定(YConnect)
 * @return NSString *
 **/
+ (NSString *)CODE_IDTOKEN {
    return CODE_IDTOKEN;
}
/**
 * アクセストークンとIDトークンの形式を指定(YConnect)
 * @return NSString *
 **/
+ (NSString *)TOKEN_IDTOKEN {
    return TOKEN_IDTOKEN;
}

@end
