//
//  TokenException.m
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import "TokenException.h"

@implementation TokenException
- (id)initWithName:(NSString*)name reason:(NSString*)reason userInfo:(NSDictionary*)userInfo {
    self =  [super initWithName:name reason:reason userInfo:userInfo];
    return self;
}

- (NSString *)toString {
    NSString *error = [NSString stringWithFormat:@"name:%@ reason:%@ userInfo:%@", [self name], [self reason], [self userInfo]];
    return error;
}

- (BOOL)isInvalidRequest {
    if ([@"invalid_request" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isUnauthorizedClient {
    if ([@"unauthorized_client" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isAccessDenied {
    if ([@"access_denied" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isUnsupportedResponseType {
    if ([@"unsupported_response_type" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isInvalidScope {
    if ([@"invalid_scope" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isServerError {
    if ([@"server_error" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
- (BOOL)isTemporarilyUnabailable {
    if ([@"temporarily_available" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
@end
