//
//  CheckIdException.m
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import "CheckIdException.h"

@implementation CheckIdException
/**
 * 初期化
 * @param NSString *name
 * @param NSString *reason
 * @param NSDictionary *userInfo
 * @return id
 **/
- (id)initWithName:(NSString*)name reason:(NSString*)reason userInfo:(NSDictionary*)userInfo {
    self =  [super initWithName:name reason:reason userInfo:userInfo];
    return self;
}
/**
 * 文字列化
 * @return NSString *
 **/
- (NSString *)toString {
    NSString *error = [NSString stringWithFormat:@"name:%@ reason:%@ userInfo:%@", [self name], [self reason], [self userInfo]];
    return error;
}
/**
 * 無効なリクエストによる例外か
 * @return BOOL
 **/
- (BOOL)isInvalidRequest {
    if ([@"invalid_request" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
/**
 * 無効なトークンによる例外か
 * @return BOOL
 **/
- (BOOL)isInvalidToken {
    if ([@"invalid_token" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
/**
 * 不十分なスコープによる例外か
 * @return BOOL
 **/
- (BOOL)isInsufficientScope {
    if ([@"insufficient_scope" isEqualToString:[self reason]]) {
        return true;
    }
    return false;
}
@end
