//
//  UserInfoClient.m
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import "UserInfoClient.h"
#import "APIClientException.h"
#import "OIDCScope.h"

@implementation UserInfoClient

- (id)initWithAccessToken:(BearerToken *)accessToken{
    self = [super initWithAccessToken:accessToken];
    return self;
}

- (id)initWithAccessTokenString:(NSString *)accessTokenString
{
    self = [super initWithAccessTokenString:accessTokenString];
    return self;
}

- (void)fetchResource:(NSString *)url method:(NSString *)method
{
    [self setParameter:@"schema" value:[OIDCScope OPENID]];
    [super fetchResource:url method:method];
    NSString *json = self.responseBody;
    
    @try {
        self.userInfoObject = [[UserInfoObject alloc] initWithJson:json];
    }
    @catch (NSException *exception) {
        @throw [[APIClientException alloc] initWithName:@"initialize error when created instance with json" reason:exception.reason userInfo:exception.userInfo];
    }
}

- (UserInfoObject *)getUserInfoObject
{
    return self.userInfoObject;
}

@end