//
//  YConnectImplicit.h
//  YConnectSDKforIOSLibrary
//
//  Copyright (c) 2012年 Yahoo Japan Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "AuthorizationRequestClient.h"
#import "BearerToken.h"
#import "IdTokenObject.h"
#import "IdTokenVerification.h"
#import "CheckIdClient.h"
#import "OAuth2ResponseType.h"
#import "OAuth2GrantType.h"
#import "OAuth2Scope.h"
#import "OIDCPrompt.h"
#import "OIDCDisplay.h"
#import "UserInfoClient.h"
#import "UserInfoObject.h"

@interface YConnectImplicit : NSObject
@property (nonatomic, retain) NSString *responseType;
@property (nonatomic, retain) NSString *display;
@property (nonatomic, retain) NSString *prompt;
@property (nonatomic, retain) NSString *scope;
@property (nonatomic, retain) NSString *nonce;

@property (nonatomic, retain) AuthorizationRequestClient *requestClient;
@property (nonatomic, retain) BearerToken *accessToken;
@property (nonatomic, retain) NSString *idToken;
@property (nonatomic, retain) IdTokenObject *idTokenObject;
@property (nonatomic, retain) UserInfoObject *userInfoObject;

@property (nonatomic, retain) CheckIdClient *checkIdClient;
@property (nonatomic) NSTimeInterval checkIdClientTimeout;

@property (nonatomic, retain) NSMutableDictionary *parameterDictionary;

- (id)init;
- (YConnectImplicit *)initWithClientId:(NSString *)clientId
                           redirectUri:(NSString *)redirectUri
                                 state:(NSString *)state;
- (YConnectImplicit *)initWithClientId:(NSString *)clientId
 redirectUri:(NSString *)redirectUri
       state:(NSString *)state
responseType:(NSString *)responseType
      display:(NSString *)display 
      prompt:(NSString *)prompt
       scope:(NSString *)scope 
       nonce:(NSString *)nonce;

+ (YConnectImplicit *)getInstance;

- (NSURL *)generateAuthorizationUri;
- (void)parseAuthorizationResponse:(NSURL *)uri
                   customUriScheme:(NSString *)customUriScheme
                             state:(NSString *)state;
- (NSString *)getAccessToken;
- (long)getAccessTokenExpiration;
- (NSString *)getIdToken;
- (IdTokenObject *) getIdTokenObject;
- (void)requestCheckIdToken:(NSString *)idToken
                      nonce:(NSString *)nonce
                   clientId:(NSString *)clientId;
- (void)requestUserInfo:(NSString *)accessTokenString;
- (id)getUserInfoObject;
- (void)addParameter:(NSString *)parameter value:(NSString *)value;

@end
