//
//  YConnectTests.m
//  YConnectTests
//
//  Created by 大井　光太郎 on 2017/10/12.
//  Copyright © 2017年 Yahoo Japan Corporation. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <XCTest/XCTest.h>
#import "HttpHeaders.h"

@interface YConnectTests : XCTestCase

- (void)testInitWithEndpointUrl;

@end

@interface TokenClient: NSObject

- (id)initWithEndpointUrl:(NSString *)endpointUrl
        authorizationCode:(NSString *)authorizationCode
              redirectUri:(NSString *)redirectUri
                 clientId:(NSString *)clientId;
- (HttpHeaders *)setRequestHeader;

@end

NSString *TOKEN_ENDPOINT_URL = @"http://example.com/";
NSString *CODE = @"zxcvbn";
NSString *REDIRECT_URI = @"hoge://fuga";
NSString *CLIENT_ID = @"abcde";

@implementation YConnectTests

- (void)setUp
{
    [super setUp];
}

- (void)tearDown
{
    [super tearDown];
}

- (void)testInitWithEndpointUrl
{
    TokenClient *tokenClient = [[TokenClient alloc] initWithEndpointUrl:TOKEN_ENDPOINT_URL authorizationCode:CODE redirectUri:REDIRECT_URI clientId:CLIENT_ID];
    HttpHeaders *headers = [tokenClient setRequestHeader];

    HttpHeaders *expectedHeaders = [[HttpHeaders alloc] init];
    [expectedHeaders setValue:@"application/x-www-form-urlencoded;charset=UTF-8" forKey:@"Content-Type"];

    // キーのチェック
    XCTAssertEqualObjects(headers.allKeys , expectedHeaders.allKeys, @"headers keys not match expectedHeadees keys");

    // 値を含めたヘッダーのチェック
    XCTAssertEqualObjects(headers.toHeaderString , expectedHeaders.toHeaderString, @"headers not match expectedHeadees");
}

@end
